// compiled: gcc -g resolve.c -o resolve

#include <dirent.h>     /* Defines DT_* constants */
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/syscall.h>

struct linux_dirent {
    unsigned long   d_ino;
    unsigned long   d_off;
    unsigned short  d_reclen;
    char            d_name[1];
};

int main()
{
    unsigned long long fd, nread;
    char buf[0x1000];
    struct linux_dirent *d;
    int bpos;
    char d_type;

    nread = read(0, buf, 0x1000);
    printf("--------------- nread=%lld ---------------\n", nread);
    printf("inode#    file type  d_reclen  d_off   d_name\n");
    for (bpos = 0; bpos < nread;)
    {
        d = (struct linux_dirent *)(buf + bpos);
        printf("%8ld  ", d->d_ino);
        d_type = *(buf + bpos + d->d_reclen - 1);
        printf("%-10s ", (d_type == DT_REG) ? "regular" 
                        : (d_type == DT_DIR) ? "directory" 
                        : (d_type == DT_FIFO) ? "FIFO" 
                        : (d_type == DT_SOCK) ? "socket" 
                        : (d_type == DT_LNK) ? "symlink" 
                        : (d_type == DT_BLK) ? "block dev" 
                        : (d_type == DT_CHR) ? "char dev" 
                        : "???");
        printf("%4d %10lld  %s\n", d->d_reclen,
               (long long)d->d_off, d->d_name);
        bpos += d->d_reclen;
    }
}